﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
End Sub

Sub Service_Create

End Sub

Sub Service_Start (StartingIntent As Intent)
	

End Sub

Public Sub DownloadImage (Index As Int) As ResumableSub
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Download(Main.urls.Get(Index))
	Log("Downloading: " & Main.urls.Get(Index))
	Wait For (j) JobDone(j As HttpJob)
	Dim x As B4XBitmap
	If j.Success Then
		x = j.GetBitmap
	Else
		x = Main.ErrorImage
	End If
	j.Release
	Return x
End Sub

Public Sub FindImages (root As String) As ResumableSub
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Download(root)
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		Dim str As String = j.GetString
		Dim rb As RegexBuilder
		rb.Initialize
		rb.AppendEscaped("<img").Append(rb.CharAny).AppendZeroOrMore.AppendEscaped($"src=""$).StartCapture
		rb.AppendAnyBut(Array($"""$)).AppendAtLeastOne.EndCapture.Append(rb.CharQuote)
		Log(rb.Pattern)
		Dim m As Matcher = Regex.Matcher2(rb.Pattern, Regex.MULTILINE, str)
		Do While m.Find
			Dim link As String = m.Group(1)
			If link.StartsWith("http") = False Then
				If link.StartsWith("/") = False Then link = "/" & link
				link = root & link
			End If
			Main.urls.Add(link)
		Loop
	End If
	j.Release
	Return j.Success
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
